#!/usr/bin/perl -w
#
# Utility for "normalizing" XML/SGML files
# Programmed by Matti 'ccr' Hamalainen
# (C) Copyright 2007 Tecnic Software productions (TNSP)
#
my %ents;
my $entMode = 0;
my $entData;
my $entName;

while (<STDIN>) {
  if (/<!ENTITY ([a-z_]+) \"([^\"]*)\">/) {
    $ents{$1} = $2;
  } elsif (/<!ENTITY ([a-z_]+) \"(.*)$/) {
    $entName = $1;
    $entData = $2;
    $entMode = 1;
  } elsif ($entMode == 1) {
    if (/^(.*)\">/) {
      $entData .= $1;
      $ents{$entName} = $entData;
      $entMode = 0;
    } else {
      $entData .= $_;
    }
  } else {
    my $s = $_;
    while(($k, $v) = each(%ents)) {
      $s =~ s/&$k;/$v/g;
    }
    if ($s =~ /&/) {
      while(($k, $v) = each(%ents)) {
        $s =~ s/&$k;/$v/g;
      }
      if ($s =~ /&/) {
        while(($k, $v) = each(%ents)) {
          $s =~ s/&$k;/$v/g;
        }
      }
    }
    print $s;
  }
}
